

.const

; ------------------------------------------------------
; Macros

coinvoke MACRO pInterface:REQ, Interface:REQ, Function:REQ, args:VARARG
    LOCAL istatement, arg
    FOR arg, <args>     ;; run thru args to see if edx is lurking in there
        IFIDNI <&arg>, <edx>
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
    istatement CATSTR <invoke (Interface PTR[edx]).&Interface>,<_>,<&Function, pInterface>
    IFNB <args>     ;; add the list of parameter arguments if any
        istatement CATSTR istatement, <, >, <&args> 
    ENDIF 
    mov edx, pInterface
    mov edx, [edx]
    istatement
ENDM

comethod1Proto      typedef proto :DWORD
comethod2Proto      typedef proto :DWORD, :DWORD
comethod3Proto      typedef proto :DWORD, :DWORD, :DWORD
comethod4Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD
comethod5Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
comethod6Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD
comethod7Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD
comethod8Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD
comethod9Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD
comethod10Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
comethod11Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD
comethod12Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD
comethod13Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD
comethod14Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD
comethod15Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
comethod16Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD
comethod17Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD
comethod18Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD
comethod19Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD
comethod20Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

comethod1           typedef ptr comethod1Proto
comethod2           typedef ptr comethod2Proto
comethod3           typedef ptr comethod3Proto
comethod4           typedef ptr comethod4Proto
comethod5           typedef ptr comethod5Proto
comethod6           typedef ptr comethod6Proto
comethod7           typedef ptr comethod7Proto
comethod8           typedef ptr comethod8Proto
comethod9           typedef ptr comethod9Proto
comethod10          typedef ptr comethod10Proto
comethod11          typedef ptr comethod11Proto
comethod12          typedef ptr comethod12Proto
comethod13          typedef ptr comethod13Proto
comethod14          typedef ptr comethod14Proto
comethod15          typedef ptr comethod15Proto
comethod16          typedef ptr comethod16Proto
comethod17          typedef ptr comethod17Proto
comethod18          typedef ptr comethod18Proto
comethod19          typedef ptr comethod19Proto
comethod20          typedef ptr comethod20Proto


_vtIUnknown MACRO CastName:REQ
	&CastName&_QueryInterface	comethod3 ?
	&CastName&_AddRef		comethod1 ?
	&CastName&_Release		comethod1 ?
ENDM

IUnknown struct
	_vtIUnknown IUnknown
IUnknown ends

SAFE_RELEASE MACRO pInterface:REQ
	.if pInterface != 0
	    coinvoke pInterface,IUnknown,Release
	mov pInterface,0
	.endif
ENDM

;---------------------------------------------------------------------
; equate primitives for use with other structures besides .IF
SUCCEEDED   TEXTEQU     <!!SIGN?>
FAILED      TEXTEQU     <!!SUCCEEDED>

;---------------------------------------------------------------------
; tests the value in eax to determine if the previous COM call
; issued a passing hresult
if_SUCCEEDED MACRO
    test eax, eax
    .if SUCCEEDED
ENDM
;
;---------------------------------------------------------------------
; tests the value in eax to determine if the previous COM call
; issued a failing hresult
if_FAILED   MACRO
    test eax, eax
    .IF FAILED
ENDM


FLT4 MACRO float_number:REQ
LOCAL float_num
	.data
	 align 4
	 float_num real4 float_number
	.code
	EXITM <float_num>
ENDM

FLT8 MACRO float_number:REQ
LOCAL float_num
	.data
	 align 8
	 float_num real8 float_number
	.code
	EXITM <float_num>
ENDM

RETURN MACRO dit:REQ
	mov eax,dit
	ret
ENDM

return MACRO dit:REQ
	mov eax,dit
	ret
ENDM

; The following 2 macro's need this piece of code
; at the start of your program!!.
; .data
;	Heap dd 0
; .code
;	invoke		GetProcessHeap
;	mov		Heap,eax

Alloc_mem MACRO mem_ptr:REQ,how_much:REQ
	 invoke	HeapAlloc,Heap,HEAP_ZERO_MEMORY,how_much
	mov	mem_ptr,eax
ENDM

Delete_mem MACRO mem_ptr:REQ
	.if mem_ptr != NULL
	 invoke	HeapFree,Heap,NULL,mem_ptr
	 mov	mem_ptr,NULL
	.endif
ENDM

GUID_ADDR MACRO guid_text:REQ
	LOCAL guid_data
	.data
	 guid_data GUID guid_text
	.code
	EXITM <addr (guid_data)>
ENDM

GUID_ MACRO guid_text:REQ
	LOCAL guid_data
	.data
	 guid_data GUID guid_text
	.code
	EXITM <offset (guid_data)>
ENDM

GUID_COPY MACRO guid_dest:REQ,guid_src:REQ
	push  ecx
	mov ecx,[guid_src]
	mov [guid_dest],ecx
	mov ecx,[guid_src + 4]
	mov [guid_dest + 4],ecx
	mov ecx,[guid_src + 8]
	mov [guid_dest + 8],ecx
	mov ecx,[guid_src + 12]
	mov [guid_dest + 12],ecx
	pop	ecx
ENDM

GUID_NULL	TEXTEQU <{0,0,0,{0,0,0,0,0,0,0,0}}>


TEXT_ MACRO your_text:VARARG
	LOCAL text_string
	.data
	 text_string db your_text,0
	.code
	EXITM <addr text_string>
ENDM

m2m MACRO M1:REQ,M2:REQ
	push M2
	pop  M1
ENDM

RGB MACRO rood,groen,blauw
    EXITM %((blauw shl 16) or (groen shl 8) or (rood))
ENDM


; IPicture interface
_vtIPicture MACRO CastName:REQ
	_vtIUnknown		CastName
	&CastName&_get_Handle              comethod2  ?
	&CastName&_get_hPal                comethod2  ?
	&CastName&_get_Type                comethod2  ?
	&CastName&_get_Width               comethod2  ?
	&CastName&_get_Height              comethod2  ?
	&CastName&_Render                  comethod11 ?
	&CastName&_set_hPal                comethod2  ?
	&CastName&_get_CurDC               comethod2  ?
	&CastName&_SelectPicture           comethod4  ?
	&CastName&_get_KeepOriginalFormat  comethod2  ?
	&CastName&_put_KeepOriginalFormat  comethod2  ?
	&CastName&_PictureChanged          comethod1  ?
	&CastName&_SaveAsFile              comethod4  ?
	&CastName&_get_Attributes          comethod2  ?
ENDM

IPicture struct
	_vtIPicture IPicture
IPicture ends

; IPicture guid
IID_IPicture		TEXTEQU	<{07bf80980h,0bf32h,0101ah,{08bh,0bbh,000h,0aah,000h,030h,00ch,0abh}}>
HIMETRIC_INCH		equ	2540


PRINTER_INFO STRUCT
 PrinterNaam		dd ?
 PoortNaam			dd ?
 Attributen			dd ?
 Dummy1				dd ? 
 Dummy2				dd ? 
PRINTER_INFO ENDS


DEVICE_INFORMATION STRUCT
 horzres			dd ?
 vertres			dd ?
 horzsize			dd ?
 vertsize			dd ?
 logpixelsx			dd ?
 logpixelsy			dd ?
 physicalwidth		dd ?
 physicalheight		dd ?
 physicaloffsetx	dd ?
 physicaloffsety	dd ?
 technology			dd ?
 rastercaps			dd ?
 numcolors			dd ?
DEVICE_INFORMATION ENDS

.data?
	align 4

IP_Data				dd ?
IP_Width			dd ?
IP_Height			dd ?
IP_Rect     		RECT <?>

hPrinterCombobox	dd ?
PrinterAantal		dd ?
PInfo5				dd 10 * 256 dup (?)	; maximaal 10 printers
     
.data
	align 4

	printer_info	DEVICE_INFORMATION <>
	scherm_info		DEVICE_INFORMATION <>
   	printdlg		PRINTDLG <>
   	docinfo			DOCINFO	<>
	logfont			LOGFONT <>
	textmetrics		TEXTMETRIC <>

	IP_Bitmap		dd NULL
	Scherm_hdc		dd	0
	My_font			dd	0
	Old_font		dd	0
	My_pen			dd	0
	Old_pen			dd	0
	Pen_width		dd	0
	Line_hight		dd	0
	Line_Xpos		dd	0
	Line_Ypos		dd	0

	Document_title		db	"Siekmanski's document.",0
	align 4
	string_buffer		db	128 dup (0)
	DefaultPrinter		db	128 dup (0)

   .code




Load_File proc Filename:DWORD
   LOCAL   hFile,dwLength,dwReadbytes,pPTR:DWORD

   invoke  CreateFile,Filename,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
   inc     eax
   jz      Error
   dec     eax
   mov     hFile,eax
   invoke  GetFileSize,hFile,NULL
   inc     eax
   jz      Error
   dec     eax
   mov     dwLength,eax

   Alloc_mem   pPTR,dwLength
   test    eax,eax
   jz      Error

   invoke  ReadFile,hFile,pPTR,dwLength,addr dwReadbytes,NULL
   test    eax,eax
   jz      Error
   invoke  CloseHandle,hFile
   mov     eax,pPTR
   mov     ecx,dwLength
Error:
   ret
Load_File endp


Load_Bitmap proc  uses esi edi PictureName:DWORD,BitmapID:DWORD,PowerOf2:DWORD
 local PictureBuffer:dword
 local RsrcData:dword
 local RsrcSize:dword
 local hRsrc:dword
 local pStream:dword
 local IBitmap:dword
 local pPicture:dword
 local hdcTemp:HDC
 local binfo:BITMAPINFO
 local IPicWidth:dword
 local IPicHeight:dword
                
   invoke  FindResource,NULL,PictureName,TEXT_("PICTURE")
   test    eax,eax
   jz      Find_Picture ; No picture in the resource, so look somewhere else
   mov     hRsrc,eax

   invoke  SizeofResource,NULL,eax
   mov     RsrcSize,eax

   Alloc_mem   PictureBuffer,eax
   test    eax,eax
   jz      Err_PIC_Load

   invoke  LoadResource,NULL,hRsrc
   invoke  LockResource,eax
   mov     RsrcData,eax

   mov     esi,RsrcData
   mov     edi,PictureBuffer
   mov     ecx,RsrcSize
   cld
   rep     movsb

   jmp     Loading_pic

Find_Picture:
   invoke  Load_File,PictureName
   test    eax,eax
   jz      Err_PIC_Load
   mov     PictureBuffer,eax

Loading_pic:
   invoke  CreateStreamOnHGlobal,PictureBuffer,TRUE,addr pStream
   cmp     eax,S_OK
   jne     Err_PIC_CStream

   invoke  OleLoadPicture,pStream,NULL,TRUE,GUID_ADDR(IID_IPicture),addr pPicture
   cmp     eax,S_OK
   jne Err_PIC_Stream

   invoke  GetDC,NULL
   push    eax
   invoke  CreateCompatibleDC,eax
   mov     hdcTemp,eax
   pop     eax
   invoke  DeleteDC,eax

           ; Get IPicture width and height
   coinvoke pPicture,IPicture,get_Width,addr IPicWidth
   coinvoke pPicture,IPicture,get_Height,addr IPicHeight

           ; Convert to pixels
   invoke  GetDeviceCaps,hdcTemp,LOGPIXELSX
   invoke  MulDiv,IPicWidth,eax,HIMETRIC_INCH
   mov     IP_Width,eax
   invoke  GetDeviceCaps,hdcTemp,LOGPIXELSY
   invoke  MulDiv,IPicHeight,eax,HIMETRIC_INCH
   mov     IP_Height,eax

   invoke  RtlZeroMemory,addr binfo.bmiHeader,sizeof BITMAPINFOHEADER

   mov     binfo.bmiHeader.biSize,sizeof BITMAPINFOHEADER
   mov     binfo.bmiHeader.biBitCount,32    ; we want only 32 bit
   mov     eax,IP_Width
   mov     binfo.bmiHeader.biWidth,eax
   mov     eax,IP_Height
   mov     binfo.bmiHeader.biHeight,eax
   mov     binfo.bmiHeader.biCompression,BI_RGB
   mov     binfo.bmiHeader.biPlanes,1

   ; we do a "CreateDIBSection" so we have access to the pixel-data and change whatever we want......
   invoke  CreateDIBSection,hdcTemp,addr binfo,DIB_RGB_COLORS,addr IP_Data,NULL,0
   test    eax,eax
   jz      Err_PIC_DIB
   mov     IBitmap,eax

   invoke  SelectObject,hdcTemp,IBitmap
   test    eax,eax
   jz      Err_PIC_Render

   mov     eax,IPicHeight
   neg     eax
   coinvoke pPicture,IPicture,Render,hdcTemp,0,0,IP_Width,IP_Height,0,IPicHeight,IPicWidth,eax,0
   cmp     eax,S_OK
   jne     Err_PIC_Render

   mov     ecx,BitmapID
   mov     eax,IBitmap
   mov     [ecx],eax

   invoke  DeleteDC,hdcTemp
   SAFE_RELEASE pPicture
   SAFE_RELEASE pStream
   mov		eax,TRUE
   ret
Err_PIC_Render:
   invoke  DeleteObject,IBitmap
Err_PIC_DIB:
   invoke  DeleteDC,hdcTemp
   SAFE_RELEASE pPicture
Err_PIC_Stream:
   SAFE_RELEASE pStream
   mov		eax,FALSE
   ret
Err_PIC_CStream:
   Delete_mem PictureBuffer
Err_PIC_Load:
   mov		eax,FALSE
   ret
Load_Bitmap endp


Load_Picture proc PictureName:DWORD
LOCAL Bitmap:DWORD

   .if (IP_Bitmap)
     invoke  DeleteObject,IP_Bitmap
	 mov	 IP_Bitmap,NULL
   .endif

	invoke	Load_Bitmap,PictureName,addr Bitmap,FALSE
   .if (eax == FALSE)
       invoke MessageBox,NULL,TEXT_("Load_Bitmap FAILED"),TEXT_("Load_Bitmap"),MB_OK
       return E_FAIL
   .endif

	mov		eax,Bitmap
	mov		IP_Bitmap,eax
   return S_OK
Load_Picture endp

Print_Bitmap proc uses esi htempDC:DWORD,X_start:DWORD,Y_start:DWORD,Breedte:DWORD,Hoogte:DWORD
LOCAL hdcPic:DWORD

	invoke	CreateCompatibleDC,htempDC
	mov		hdcPic,eax
	invoke	SelectObject,hdcPic,IP_Bitmap

;	invoke	BitBlt,htempDC,400,200,856,892,hdcPic,0,0,SRCCOPY
		
   invoke  StretchBlt,htempDC,X_start,Y_start,Breedte,Hoogte,hdcPic,0,0,IP_Width,IP_Height,SRCCOPY

   invoke  DeleteDC,hdcPic

   return  S_OK
Print_Bitmap endp



Get_fontline_height	proc	rDC:DWORD
			invoke	GetTextMetrics,rDC,addr textmetrics
			mov		eax,textmetrics.tmHeight
			add		eax,textmetrics.tmExternalLeading
			ret
Get_fontline_height	endp


Get_font	proc 	f_name:DWORD,f_height:DWORD,m_logpixelsy:DWORD
			push	edx
			push	ecx
			mov		eax,m_logpixelsy
			mul 	f_height
			mov 	ecx,72
			xor 	edx,edx
			div 	ecx
			neg 	eax
			pop		ecx
			push	edx
			mov		logfont.lfHeight,eax
			mov 	logfont.lfWidth,0
			mov 	logfont.lfEscapement,0
			mov 	logfont.lfOrientation,0
			mov 	logfont.lfWeight,FW_NORMAL
			mov 	logfont.lfItalic,FALSE
			mov 	logfont.lfUnderline,FALSE
			mov 	logfont.lfStrikeOut,FALSE
			mov 	logfont.lfCharSet,DEFAULT_CHARSET
			mov 	logfont.lfOutPrecision,OUT_DEFAULT_PRECIS
			mov 	logfont.lfClipPrecision,CLIP_DEFAULT_PRECIS
			mov		logfont.lfQuality,DEFAULT_QUALITY
			invoke	lstrcpy,addr logfont.lfFaceName,f_name
			invoke	CreateFontIndirect,addr logfont
			ret
Get_font	endp


Get_deviceinfo proc m_device:DWORD,m_info:DWORD
			push	edi
    		mov		edi,m_info
			invoke	GetDeviceCaps,m_device,HORZRES
			mov		[edi].DEVICE_INFORMATION.horzres,eax
			invoke	GetDeviceCaps,m_device,VERTRES
			mov		[edi].DEVICE_INFORMATION.vertres,eax
			invoke	GetDeviceCaps,m_device,HORZSIZE
			mov		[edi].DEVICE_INFORMATION.horzsize,eax
			invoke	GetDeviceCaps,m_device,VERTSIZE
			mov		[edi].DEVICE_INFORMATION.vertsize,eax
			invoke	GetDeviceCaps,m_device,LOGPIXELSX
			mov		[edi].DEVICE_INFORMATION.logpixelsx,eax
			invoke	GetDeviceCaps,m_device,LOGPIXELSY
			mov		[edi].DEVICE_INFORMATION.logpixelsy,eax
			invoke	GetDeviceCaps,m_device,PHYSICALWIDTH
			mov		[edi].DEVICE_INFORMATION.physicalwidth,eax
			invoke	GetDeviceCaps,m_device,PHYSICALHEIGHT
			mov		[edi].DEVICE_INFORMATION.physicalheight,eax
			invoke	GetDeviceCaps,m_device,PHYSICALOFFSETX
			mov		[edi].DEVICE_INFORMATION.physicaloffsetx,eax
			invoke	GetDeviceCaps,m_device,PHYSICALOFFSETY
			mov		[edi].DEVICE_INFORMATION.physicaloffsety,eax
			invoke	GetDeviceCaps,m_device,TECHNOLOGY
			mov		[edi].DEVICE_INFORMATION.technology,eax
			invoke	GetDeviceCaps,m_device,RASTERCAPS
			mov		[edi].DEVICE_INFORMATION.rastercaps,eax
			invoke	GetDeviceCaps,m_device,NUMCOLORS
			mov		[edi].DEVICE_INFORMATION.numcolors,eax
			pop		edi
			ret
Get_deviceinfo endp

Get_printer proc	Printer_Flags:DWORD
		.if	printdlg.hDC
			invoke	DeleteDC,printdlg.hDC
		.endif

			invoke	RtlZeroMemory,addr printdlg,sizeof printdlg
			mov		printdlg.lStructSize,sizeof printdlg
			m2m		printdlg.hWndOwner,hWnd
			mov		printdlg.hDC,NULL
			m2m		printdlg.hInstance,hInstance
			m2m		printdlg.Flags,Printer_Flags
			mov		printdlg.nCopies,1
			invoke	PrintDlg,addr printdlg		
			cmp		eax,TRUE
			je		Printer_OK
    		invoke  MessageBox,hWnd,TEXT_("Printer error !"),TEXT_("PRINTER_INFO.."),MB_ICONERROR
			mov		eax,FALSE
			ret
Printer_OK:
			invoke	Get_deviceinfo,printdlg.hDC,addr printer_info
			mov		eax,TRUE
			ret
Get_printer endp


Andere_printer proc	PrinterNr:DWORD
		.if	printdlg.hDC
			invoke	DeleteDC,printdlg.hDC
		.endif
		lea		esi,PInfo5
		mov		eax,sizeof PRINTER_INFO
		mul		PrinterNr
		add		esi,eax		
	    invoke  CreateDC,NULL,PRINTER_INFO.PrinterNaam[esi],NULL,NULL
	    mov	    printdlg.hDC,eax
		ret
Andere_printer endp



PrinterComboBox proc Combo_ID:dword
align 4
LOCAL	Combobox_teller,DefaultNr,dwBytesNodig,dwAantalPrinters:dword
LOCAL	dwReturned:dword
	invoke	GetDefaultPrinter,addr DefaultPrinter,addr dwReturned


	invoke	GetDlgItem,hWnd,Combo_ID
	mov		hPrinterCombobox,eax
		
	invoke	EnumPrinters,PRINTER_ENUM_LOCAL or PRINTER_ENUM_CONNECTIONS,NULL,5,NULL,0,addr dwBytesNodig,addr dwAantalPrinters	; hoeveel printers zijn er ???
	invoke	EnumPrinters,PRINTER_ENUM_LOCAL or PRINTER_ENUM_CONNECTIONS,NULL,5,addr PInfo5,dwBytesNodig,addr dwBytesNodig,addr dwAantalPrinters

	mov		DefaultNr,0
	mov		Combobox_teller,0
	lea		esi,PInfo5
Combo_lp:

	invoke	lstrcmp,PRINTER_INFO.PrinterNaam[esi],addr DefaultPrinter
	jnz		geen_default_printer
	mov		eax,Combobox_teller
	mov		DefaultNr,eax		
geen_default_printer:		      			

	invoke	wsprintf,addr string_buffer,TEXT_("%s"),PRINTER_INFO.PrinterNaam[esi]
	invoke	SendMessage,hPrinterCombobox,CB_ADDSTRING,0,addr string_buffer

	add		esi,sizeof PRINTER_INFO

	inc		Combobox_teller
	mov		eax,Combobox_teller
	cmp		eax,dwAantalPrinters
	jne		Combo_lp

	invoke	SendMessage,hPrinterCombobox,CB_SETCURSEL,DefaultNr,0	
	ret
PrinterComboBox endp



Open_Printer proc DC_ID:dword
	invoke	PrinterComboBox,IDC_PRINTER_COMBO
	invoke	Get_deviceinfo,DC_ID,addr scherm_info
	; pak "Default Printer"
	invoke	Get_printer,PD_RETURNDC OR PD_RETURNDEFAULT
	ret
Open_Printer endp

Sluit_Printer proc
	
	.if	printdlg.hDC
		invoke	DeleteDC,printdlg.hDC
	.endif
	ret
Sluit_Printer endp

Bereken_lijnlengteX proc millimeters:dword
			mov		eax,printer_info.horzres
			mul		millimeters
			xor		edx,edx
			div		printer_info.horzsize
			mov		edx,Pen_width
;			shr		edx,1		; Pen_width / 2
			sub		eax,edx
			ret
Bereken_lijnlengteX endp

Bereken_lijnlengteY proc millimeters:dword
			mov		eax,printer_info.vertres
			mul		millimeters
			xor		edx,edx
			div		printer_info.vertsize
			mov		edx,Pen_width
;			shr		edx,1		; Pen_width / 2
			sub		eax,edx
			ret
Bereken_lijnlengteY endp

Print_routine	proc
			invoke	Get_font,TEXT_("comic sans ms"),15,printer_info.logpixelsy
			mov		My_font,eax
			invoke	SelectObject,printdlg.hDC,My_font
			mov		Old_font,eax

			invoke	SetTextColor,printdlg.hDC,RGB(0,0,0)

			invoke	Get_fontline_height,printdlg.hDC
			mov		Line_hight,eax

			mov		Pen_width,20
			invoke	CreatePen,PS_SOLID,Pen_width,RGB(0,0,0)	;rgbColor
			mov		My_pen,eax					;Mijn lijn instellingen.
			invoke	SelectObject,printdlg.hDC,My_pen
			mov		Old_pen,eax

			invoke	SetBkMode,printdlg.hDC,TRANSPARENT

			mov		docinfo.cbSize,sizeof docinfo
			mov		docinfo.lpszDocName,offset Document_title
			mov		docinfo.lpszOutput,NULL
			mov		docinfo.lpszDatatype,NULL
			mov		docinfo.fwType,NULL

			invoke	StartDoc,printdlg.hDC,addr docinfo
			invoke	StartPage,printdlg.hDC


	; Drawing a rectangle at the boundaries of the printable area
			push	ebx
			push	ecx
			mov		eax,Pen_width
			shr		eax,1		; Pen_width / 2
			mov		ebx,printer_info.horzres
			sub		ebx,eax
			mov		ecx,printer_info.vertres
			sub		ecx,eax
			invoke  Rectangle,printdlg.hDC,eax,eax,ebx,ecx
			pop		ecx
			pop		ebx

			mov		Line_Xpos,100
			mov		Line_Ypos,100


			invoke	Load_Picture,TEXT_("Jump.bmp")				; print on the background
			invoke	Print_Bitmap,printdlg.hDC,100,1000,1200,800

			invoke	wsprintf,addr string_buffer,TEXT_("HORZRES = %d  ( Width of the printable area in pixels. )"),printer_info.horzres
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("VERTRES = %d  ( Height of the printable area in pixels. )"),printer_info.vertres
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("HORZSIZE = %d  ( Width of the printable area in millimeters. )"),printer_info.horzsize
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("VERTSIZE = %d  ( Height of the printable area in millimeters. )"),printer_info.vertsize
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("LOGPIXELSX = %d  ( Horizontal pixels per inch 'DPI'. )"),printer_info.logpixelsx
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("LOGPIXELSY = %d  ( Vertical pixels per inch 'DPI'. )"),printer_info.logpixelsy
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("PHYSICALWIDTH = %d  ( Page width in pixels. )"),printer_info.physicalwidth
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("PHYSICALHEIGHT = %d  ( Page height in pixels. )"),printer_info.physicalheight
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("PHYSICALOFFSETX = %d  ( Left offset to printable area in pixels. )"),printer_info.physicaloffsetx
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("PHYSICALOFFSETY = %d  ( Upper offset to printable area in pixels. )"),printer_info.physicaloffsety
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("TECHNOLOGY = %d  ( Type output-device. )"),printer_info.technology
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("RASTERCAPS = %d  ( Type printer-BitBlts. )"),printer_info.rastercaps
			invoke  lstrlen,addr string_buffer
  			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax

 			mov		eax,Line_hight
			add		Line_Ypos,eax

			invoke	wsprintf,addr string_buffer,TEXT_("NUMCOLORS = %d  ( Number of colors. )"),printer_info.numcolors
			invoke  lstrlen,addr string_buffer
 			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax


 			mov		eax,Line_hight
			add		Line_Ypos,eax
			
			
			invoke  MoveToEx,printdlg.hDC,100,Line_Ypos,NULL
			invoke	Bereken_lijnlengteX,100	; 100 mm == 10 cm
			add		eax,100
			invoke  LineTo,printdlg.hDC,eax,Line_Ypos

			invoke  MoveToEx,printdlg.hDC,100,Line_Ypos,NULL
			invoke	Bereken_lijnlengteX,120	; 120 mm == 12 cm
			add		eax,Line_Ypos
			invoke  LineTo,printdlg.hDC,100,eax


 			mov		eax,Line_hight
			shl		eax,2
			add		Line_Ypos,eax

			invoke	Get_font,TEXT_("Arial"),48,printer_info.logpixelsy
			mov		My_font,eax
			invoke	SelectObject,printdlg.hDC,My_font
			invoke	SetTextColor,printdlg.hDC,RGB(255,0,0)
			invoke	wsprintf,addr string_buffer,TEXT_("Have FUN: Siekmanski")
			invoke  lstrlen,addr string_buffer
 			invoke	TextOut,printdlg.hDC,Line_Xpos,Line_Ypos,addr string_buffer,eax


			invoke	Load_Picture,ID_SpacePic				; load from resource
			invoke	Print_Bitmap,printdlg.hDC,100,100,800,600

			invoke	Load_Picture,TEXT_("Devo.jpg")
			invoke	Print_Bitmap,printdlg.hDC,2000,100,1800,1600

  			invoke	EndPage,printdlg.hDC
  			invoke	EndDoc,printdlg.hDC


			invoke	SelectObject,printdlg.hDC,Old_font
			invoke	DeleteObject,eax
			invoke	SelectObject,printdlg.hDC,Old_pen
			invoke	DeleteObject,eax
			ret
Print_routine	endp
